(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['module', 'exports'], factory);
  } else if (typeof exports !== "undefined") {
    factory(module, exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod, mod.exports);
    global.index = mod.exports;
  }
})(this, function (module, exports) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };

  var isObject = function isObject(o) {
    return o != null && (typeof o === 'undefined' ? 'undefined' : _typeof(o)) === 'object';
  };
  var isEmpty = function isEmpty(o) {
    return Object.keys(o).length === 0;
  };

  var diff = function diff(lhs, rhs) {
    if (lhs === rhs) return {};

    if (!isObject(lhs) || !isObject(rhs)) return rhs;

    var rhsKeys = Object.keys(rhs);

    var deletedValues = Object.keys(lhs).reduce(function (acc, key) {
      return rhsKeys.indexOf(key) !== -1 ? acc : _extends({}, acc, _defineProperty({}, key, undefined));
    }, {});

    return rhsKeys.reduce(function (acc, key) {
      if (!lhs.hasOwnProperty(key)) return _extends({}, acc, _defineProperty({}, key, rhs[key]));

      var difference = diff(lhs[key], rhs[key]);

      if (isObject(difference) && isEmpty(difference)) return acc;

      return _extends({}, acc, _defineProperty({}, key, difference));
    }, deletedValues);
  };

  exports.default = diff;
  module.exports = exports['default'];
});